unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  BGRABitmap, BGRASvg;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    RadioGroup1: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    procedure LoadSVGFromResource(AResourceName: String);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLType;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  RadioGroup1Click(nil);
end;

procedure TForm1.LoadSVGFromResource(AResourceName: String);
var
  stream: TStream;
  bmp: TBGRABitmap;
  svg: TBGRASVG;
begin
  bmp:= TBGRABitmap.Create;
  try
    stream := TResourceStream.Create(HINSTANCE, AResourceName, RT_RCDATA);
    try
      svg:= TBGRASVG.Create(stream);
      try
        if (Image1.Width > 0) and (Image1.Height > 0) then
        begin
          bmp.SetSize(Round(Image1.Width),Round(Image1.Height));
          bmp.Fill(clSilver);
          svg.StretchDraw(bmp.Canvas2D, taCenter, tlCenter, 0,0,Image1.Width,Image1.Height);
          Image1.Picture.Bitmap.Assign(bmp);
        end;
      finally
        svg.Free;
      end;
    finally
      stream.Free;
    end;
  finally
    bmp.Free;
  end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  LoadSVGFromResource(RadioGroup1.Items[RadioGroup1.ItemIndex]);
end;

end.

